// Code generated by protoc-gen-go-grpc. DO NOT EDIT.

package item

import (
	context "context"

	grpc "google.golang.org/grpc"
	codes "google.golang.org/grpc/codes"
	status "google.golang.org/grpc/status"
)

// This is a compile-time assertion to ensure that this generated file
// is compatible with the grpc package it is being compiled against.
// Requires gRPC-Go v1.32.0 or later.
const _ = grpc.SupportPackageIsVersion7

// ItemSrvClient is the client API for ItemSrv service.
//
// For semantics around ctx use and closing/ending streaming RPCs, please refer to https://pkg.go.dev/google.golang.org/grpc/?tab=doc#ClientConn.NewStream.
type ItemSrvClient interface {
	GetItems(ctx context.Context, in *ItemRequest, opts ...grpc.CallOption) (ItemSrv_GetItemsClient, error)
	Search(ctx context.Context, in *SearchRequest, opts ...grpc.CallOption) (ItemSrv_SearchClient, error)
	GetDetail(ctx context.Context, in *DetailRequest, opts ...grpc.CallOption) (*DetailReply, error)
}

type itemSrvClient struct {
	cc grpc.ClientConnInterface
}

func NewItemSrvClient(cc grpc.ClientConnInterface) ItemSrvClient {
	return &itemSrvClient{cc}
}

func (c *itemSrvClient) GetItems(ctx context.Context, in *ItemRequest, opts ...grpc.CallOption) (ItemSrv_GetItemsClient, error) {
	stream, err := c.cc.NewStream(ctx, &ItemSrv_ServiceDesc.Streams[0], "/ItemSrv/GetItems", opts...)
	if err != nil {
		return nil, err
	}
	x := &itemSrvGetItemsClient{stream}
	if err := x.ClientStream.SendMsg(in); err != nil {
		return nil, err
	}
	if err := x.ClientStream.CloseSend(); err != nil {
		return nil, err
	}
	return x, nil
}

type ItemSrv_GetItemsClient interface {
	Recv() (*Item, error)
	grpc.ClientStream
}

type itemSrvGetItemsClient struct {
	grpc.ClientStream
}

func (x *itemSrvGetItemsClient) Recv() (*Item, error) {
	m := new(Item)
	if err := x.ClientStream.RecvMsg(m); err != nil {
		return nil, err
	}
	return m, nil
}

func (c *itemSrvClient) Search(ctx context.Context, in *SearchRequest, opts ...grpc.CallOption) (ItemSrv_SearchClient, error) {
	stream, err := c.cc.NewStream(ctx, &ItemSrv_ServiceDesc.Streams[1], "/ItemSrv/Search", opts...)
	if err != nil {
		return nil, err
	}
	x := &itemSrvSearchClient{stream}
	if err := x.ClientStream.SendMsg(in); err != nil {
		return nil, err
	}
	if err := x.ClientStream.CloseSend(); err != nil {
		return nil, err
	}
	return x, nil
}

type ItemSrv_SearchClient interface {
	Recv() (*Item, error)
	grpc.ClientStream
}

type itemSrvSearchClient struct {
	grpc.ClientStream
}

func (x *itemSrvSearchClient) Recv() (*Item, error) {
	m := new(Item)
	if err := x.ClientStream.RecvMsg(m); err != nil {
		return nil, err
	}
	return m, nil
}

func (c *itemSrvClient) GetDetail(ctx context.Context, in *DetailRequest, opts ...grpc.CallOption) (*DetailReply, error) {
	out := new(DetailReply)
	err := c.cc.Invoke(ctx, "/ItemSrv/GetDetail", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

// ItemSrvServer is the server API for ItemSrv service.
// All implementations must embed UnimplementedItemSrvServer
// for forward compatibility
type ItemSrvServer interface {
	GetItems(*ItemRequest, ItemSrv_GetItemsServer) error
	Search(*SearchRequest, ItemSrv_SearchServer) error
	GetDetail(context.Context, *DetailRequest) (*DetailReply, error)
	mustEmbedUnimplementedItemSrvServer()
}

// UnimplementedItemSrvServer must be embedded to have forward compatible implementations.
type UnimplementedItemSrvServer struct {
}

func (UnimplementedItemSrvServer) GetItems(*ItemRequest, ItemSrv_GetItemsServer) error {
	return status.Errorf(codes.Unimplemented, "method GetItems not implemented")
}
func (UnimplementedItemSrvServer) Search(*SearchRequest, ItemSrv_SearchServer) error {
	return status.Errorf(codes.Unimplemented, "method Search not implemented")
}
func (UnimplementedItemSrvServer) GetDetail(context.Context, *DetailRequest) (*DetailReply, error) {
	return nil, status.Errorf(codes.Unimplemented, "method GetDetail not implemented")
}
func (UnimplementedItemSrvServer) mustEmbedUnimplementedItemSrvServer() {}

// UnsafeItemSrvServer may be embedded to opt out of forward compatibility for this service.
// Use of this interface is not recommended, as added methods to ItemSrvServer will
// result in compilation errors.
type UnsafeItemSrvServer interface {
	mustEmbedUnimplementedItemSrvServer()
}

func RegisterItemSrvServer(s grpc.ServiceRegistrar, srv ItemSrvServer) {
	s.RegisterService(&ItemSrv_ServiceDesc, srv)
}

func _ItemSrv_GetItems_Handler(srv interface{}, stream grpc.ServerStream) error {
	m := new(ItemRequest)
	if err := stream.RecvMsg(m); err != nil {
		return err
	}
	return srv.(ItemSrvServer).GetItems(m, &itemSrvGetItemsServer{stream})
}

type ItemSrv_GetItemsServer interface {
	Send(*Item) error
	grpc.ServerStream
}

type itemSrvGetItemsServer struct {
	grpc.ServerStream
}

func (x *itemSrvGetItemsServer) Send(m *Item) error {
	return x.ServerStream.SendMsg(m)
}

func _ItemSrv_Search_Handler(srv interface{}, stream grpc.ServerStream) error {
	m := new(SearchRequest)
	if err := stream.RecvMsg(m); err != nil {
		return err
	}
	return srv.(ItemSrvServer).Search(m, &itemSrvSearchServer{stream})
}

type ItemSrv_SearchServer interface {
	Send(*Item) error
	grpc.ServerStream
}

type itemSrvSearchServer struct {
	grpc.ServerStream
}

func (x *itemSrvSearchServer) Send(m *Item) error {
	return x.ServerStream.SendMsg(m)
}

func _ItemSrv_GetDetail_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(DetailRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(ItemSrvServer).GetDetail(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/ItemSrv/GetDetail",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(ItemSrvServer).GetDetail(ctx, req.(*DetailRequest))
	}
	return interceptor(ctx, in, info, handler)
}

// ItemSrv_ServiceDesc is the grpc.ServiceDesc for ItemSrv service.
// It's only intended for direct use with grpc.RegisterService,
// and not to be introspected or modified (even as a copy)
var ItemSrv_ServiceDesc = grpc.ServiceDesc{
	ServiceName: "ItemSrv",
	HandlerType: (*ItemSrvServer)(nil),
	Methods: []grpc.MethodDesc{
		{
			MethodName: "GetDetail",
			Handler:    _ItemSrv_GetDetail_Handler,
		},
	},
	Streams: []grpc.StreamDesc{
		{
			StreamName:    "GetItems",
			Handler:       _ItemSrv_GetItems_Handler,
			ServerStreams: true,
		},
		{
			StreamName:    "Search",
			Handler:       _ItemSrv_Search_Handler,
			ServerStreams: true,
		},
	},
	Metadata: "item.proto",
}
